#include <iostream>
#include <vector>
#include <queue>
#include <cstdlib>
using namespace std;

int V, E;
int vis[30001] = {0};
int parent[30001] = {0};
vector<int> G[30001];

void bfs(int s)
{
  queue<int> Q;
  vis[s] = 1; // 1 = róże, -1 = lilie
  Q.push(s);
  while(!Q.empty())
  {
    int v = Q.front(); Q.pop();
    for(int i=0; i<int(G[v].size()); i++)
    {
      int k = G[v][i];
      if(vis[k]==0)
      {
        vis[k] = -vis[v];
        parent[k] = v;
        Q.push(k);
        continue;
      }
      if(vis[k]==vis[v])
      {
        cout << "NIE" << endl;
        exit(0);
      }
    }
  }
}

int main()
{
  ios_base::sync_with_stdio(0);
  cin >> V >> E;
  for(int i=0; i<E; i++)
  {
    int a, b;
    cin >> a >> b;
    G[a].push_back(b);
    G[b].push_back(a);
  }
  for(int s=1; s<=V; s++)
    if(vis[s]==0) bfs(s);
  cout << "TAK" << endl;
}